#include<string>
#include<iostream>
#include<vector>
#include<algorithm> //std::sort
#include<cctype> //std::tolower
 
using namespace std;
 
void print(vector<string> const& v) {
  for (vector<string>::const_iterator it=v.begin(); it!=v.end(); ++it) {
    cout<<*it<<"\n";
  }
}

bool compare_nocase (string s1, string s2) {
  unsigned int i=0;
  while ( (i<s1.length()) && (i<s2.length()) ) {
    if (tolower(s1[i])<tolower(s2[i])) return true;
    else if (tolower(s1[i])>tolower(s2[i])) return false;
    ++i;
  }
  return s1.length()<s2.length();
}

bool compare_length(string s1, string s2) {
  return s1.length()<s2.length();
}

int main() {
  vector<string> v;
  v.push_back("Hamburg");
  v.push_back("Aachen");
  v.push_back("Karlsruhe");
  v.push_back("Berlin");
  v.push_back("BER");
  v.push_back("BERLIN");
 
  vector<string> v1(v);
  sort(v1.begin(),v1.end());
  print(v1);
 
  cout<<endl;
 
  v1=v;
  sort(v1.begin(),v1.end(),compare_length);
  print(v1);
 
  cout<<endl;
 
  v1=v;
  sort(v1.begin(),v1.end(),compare_nocase);
  print(v1);
 
  return 0;
}

