#define MAIN_CPP
 
#include <iostream>
#include <exception>
#include "readparameters.h"
 
using namespace std;
 
int main(int argc,char **argv){ 
  //check arguments
  if (argc!=2) {
    cerr<<"Usage: ./params <paramfile>"<<endl;
    return 1;
  } 
 
  //get input filename from parameter file
  int answer;
  vector<string> v;
  try { 
      readparameters rp(argv[1]);
      answer = rp.get<int>("answer");
      v=rp.get_vector<string>("parser_test");
      cout<<answer<<endl;
      rp.print_tabular(); //debug output
      rp.get<long>("Atlantis"); //exception
 
  }
  catch (exception& e) {
      cerr<<e.what()<<endl;
      return 1;
  }
 
  return 0;
}
